var Spellbook = {};

$(function() {
  $.getJSON('../json/cards.json').done(function(data) {
    Spellbook.cards = data;
    Spellbook.list = _.map(_.pluck(Spellbook.cards, 'name'), function(name) {
      return name;
    });
  });
  
  $('#query').keyup(function() {
    var length = $('#query').val().length;
    if (length > 1) {
      var results = _.filter(Spellbook.list, function(name) {
        if (name.toLowerCase().indexOf($('#query').val().toLowerCase()) > -1) {
          return true;
        } else {
          return false;
        }
      });
      if (results.length > 1) {
        $('#results').html('<ul></ul>');
        _.each(results, function(name) {
          $('#results ul').append('<li>' + name + '</li>');
        });
      } else if (results.length === 1) {
        show(_.findWhere(Spellbook.cards, { name: results[0] }));
      }
      
      _.each(results, function(name) {
        if (name.toLowerCase() === $('#query').val().toLowerCase()) {
          show(_.findWhere(Spellbook.cards, { name: name }));
        }
      });
    }
  });
  
  function show(card) {
    $('#card div, #card h1, #card p, #card h3').html('');
    $('#card').focus();
    $('#results').html('<ul></ul>');
    $('#title').html(card.name);
    if (card.type[0] !== 'Land') {
      card.cost = replaceSymbols(card.cost);
      $('#cost').html(card.cost);
    } else {
      $('#cost').html('');
    }
    if (card.supertype) {
      $('#type').append(card.supertype.join(' ') + ' ');
    }
    $('#type').append(card.type.join(' '));
    if (card.subtype) {
      $('#type').append(' — ' + card.subtype.join(' '));
    }
    if (card.power || card.toughness) {
      $('#powtgh').html(card.power + '/' + card.toughness);
    }
    $('#rules').html(card.rules.join('<p>'));
  }
  
  function replaceSymbols(line) {
    line = line.replace(/^([XYZ]*)20/, '\1&#9331;');
    line = line.replace(/^([XYZ]*)19/, '\1&#9330;');
    line = line.replace(/^([XYZ]*)18/, '\1&#9329;');
    line = line.replace(/^([XYZ]*)17/, '\1&#9328;');
    line = line.replace(/^([XYZ]*)16/, '\1&#9327;');
    line = line.replace(/^([XYZ]*)15/, '\1&#9326;');
    line = line.replace(/^([XYZ]*)14/, '\1&#9325;');
    line = line.replace(/^([XYZ]*)13/, '\1&#9324;');
    line = line.replace(/^([XYZ]*)12/, '\1&#9323;');
    line = line.replace(/^([XYZ]*)11/, '\1&#9322;');
    line = line.replace(/^([XYZ]*)10/, '\1&#9321;');
    line = line.replace(/^([XYZ]*)9/, '\1&#9320;');
    line = line.replace(/^([XYZ]*)8/, '\1&#9319;');
    line = line.replace(/^([XYZ]*)7/, '\1&#9318;');
    line = line.replace(/^([XYZ]*)6/, '\1&#9317;');
    line = line.replace(/^([XYZ]*)5/, '\1&#9316;');
    line = line.replace(/^([XYZ]*)4/, '\1&#9315;');
    line = line.replace(/^([XYZ]*)3/, '\1&#9314;');
    line = line.replace(/^([XYZ]*)2/, '\1&#9313;');
    line = line.replace(/^([XYZ]*)1/, '\1&#9312;');
    line = line.replace(/^([XYZ]*)0/, '\1&#9450;');
    line = line.replace(/[W]/g, '&#9420;');
    line = line.replace(/[U]/g, '&#9418;');
    line = line.replace(/[B]/g, '&#9399;');
    line = line.replace(/[R]/g, '&#9415;');
    line = line.replace(/[G]/g, '&#9404;');
    line = line.replace(/[X]/g, '&#9421;');
    line = line.replace(/[Y]/g, '&#9422;');
    line = line.replace(/[Z]/g, '&#9423;');
    return line;
  }
});